﻿Imports System.Text
Imports System.Text.RegularExpressions
Imports Newtonsoft.Json

Public Class CnslFns
    'Public Const DspHelp As String = "←F1"
    'Public Const AskAgain As String = "←F2"
    'Public Const Examples As String = "←F3"
    'Public Const CLS As String = "←F4"
    'Public Const Quit As String = "←F5"
    'Public Shared vAll() As String = {Examples, AskAgain, Quit}
    Shared config As String = IO.File.ReadAllText("FunctionKeys.json")
    Public Shared functionKeys As Dictionary(Of String, String) = JsonConvert.DeserializeObject(Of Dictionary(Of String, String))(config)
    Public Shared Function IsNotAFunctKey(s As String) As Boolean
        Return s.Length = 0 OrElse AscW(s) <> 27
    End Function
End Class
Public Class Cnsl
    Shared lstLines As New List(Of String)
    Shared currLstLines As Int32
    Shared sb As StringBuilder
    Public Shared Function ReadLine(strToWrite As String,
                      intercept As Boolean,
                      Optional saveInput As Boolean = True,
                      Optional defaultValue As String = "",
                      Optional minLength As Int32 = 1) As String

        If Not intercept Then Return Console.ReadLine
        currLstLines = lstLines.Count - 1
        Console.Write(strToWrite)
        If strToWrite.EndsWith(vbCrLf) Then strToWrite = ""
        sb = New StringBuilder(defaultValue)
        Dim leftIni As Int32 = Console.CursorLeft
        If sb.Length Then Console.Write(sb.ToString)
        Dim top As Int32 = Console.CursorTop
        Dim position As Int32 = Console.CursorLeft - strToWrite.Length
        Dim sblen As Int32 = sb.Length
        Dim c As ConsoleKeyInfo

        Do
            c = Console.ReadKey(True)
            If Not Char.IsControl(c.KeyChar) Then
                sb.Insert(position, c.KeyChar)
                position += 1
            Else
                Select Case c.Key
                    Case ConsoleKey.Delete
                        If position < sb.Length Then
                            sb.Remove(position, 1)
                        End If
                    Case ConsoleKey.Backspace
                        If position Then
                            position -= 1
                            sb.Remove(position, 1)
                        End If
                    Case ConsoleKey.LeftArrow
                        position = Math.Max(position - 1, 0)
                    Case ConsoleKey.RightArrow
                        position = Math.Min(position + 1, sb.Length)
                    Case ConsoleKey.UpArrow
                        If currLstLines >= lstLines.Count Then
                            currLstLines = lstLines.Count - 2
                        End If
                        If currLstLines >= 0 AndAlso currLstLines < lstLines.Count Then
                            sb.Clear()
                            sb.Append(lstLines(currLstLines))
                            position = sb.Length
                        End If
                        currLstLines -= 1
                    Case ConsoleKey.DownArrow
                        If currLstLines < 0 Then
                            currLstLines = 1
                        End If
                        If currLstLines >= 0 AndAlso currLstLines < lstLines.Count Then
                            sb.Clear()
                            sb.Append(lstLines(currLstLines))
                            position = sb.Length
                            If currLstLines < lstLines.Count - 1 Then
                            End If
                        End If
                        currLstLines += 1
                    Case ConsoleKey.End
                        position = sb.Length
                    Case ConsoleKey.Home
                        position = 0
                    Case Else
                        For i As Int32 = 0 To CnslFns.functionKeys.Count - 1
                            Dim val As String = CnslFns.functionKeys.Values(i)
                            Dim m As Match = Regex.Match(val, "(S)(C)(A)")
                            Dim n As Int32 = Int32.Parse(val.Substring(1, 3))
                            Dim sSuccess As New StringBuilder("111")
                            If n = c.Key Then
                                If m.Groups(0).Success Then
                                    If (ConsoleModifiers.Shift And c.Modifiers) = 0 Then sSuccess.Chars(0) = "0"
                                End If
                                If m.Groups(1).Success Then
                                    If (ConsoleModifiers.Control And c.Modifiers) = 0 Then sSuccess.Chars(1) = "0"
                                End If
                                If m.Groups(2).Success Then
                                    If (ConsoleModifiers.Shift And c.Modifiers) = 0 Then sSuccess.Chars(2) = "0"
                                End If
                                If sSuccess.ToString = "111" Then
                                    Select Case c.Key
                                        Case ConsoleKey.F1
                                            sb = New StringBuilder(CnslFns.functionKeys("DspHelp"))
                                            Exit Do
                                        Case ConsoleKey.F2
                                            sb = New StringBuilder(CnslFns.functionKeys("AskAgain"))
                                            Exit Do
                                        Case ConsoleKey.F3
                                            sb = New StringBuilder(CnslFns.functionKeys("Examples"))
                                            Exit Do
                                        Case ConsoleKey.F4
                                            Console.Clear()
                                            top = 0 : position = 0
                                            sb = New StringBuilder(CnslFns.functionKeys("CLS"))
                                            Exit Do
                                        Case ConsoleKey.F5
                                            sb = New StringBuilder(CnslFns.functionKeys("Quit"))
                                            Exit Do
                                        Case ConsoleKey.A
                                            End
                                    End Select
                                End If
                            End If
                        Next
                        Select Case c.Key
                            Case ConsoleKey.Escape
                                position = 0
                                sb.Clear()
                            Case ConsoleKey.Enter
                        End Select
                End Select
            End If

            Console.CursorTop = top
            Console.CursorLeft = leftIni
            Console.Write(StrDup(sblen, " "))
            Console.CursorTop = top
            Console.CursorLeft = leftIni
            sblen = sb.Length
            If sb.Length Then
                Console.Write(sb.ToString)
            End If
            Console.CursorLeft = leftIni + position
        Loop While c.Key <> ConsoleKey.Enter OrElse sb.Length < minLength
        If top + 1 < Console.BufferHeight Then
            If sb.ToString <> CnslFns.functionKeys("CLS") Then Console.CursorTop = top + 1
        Else
            Console.WriteLine("")
        End If
        Console.CursorLeft = 0
        If saveInput AndAlso Trim(sb.ToString).Length AndAlso
           CnslFns.IsNotAFunctKey(sb.ToString) Then
            lstLines.Add(sb.ToString)
        End If
        Return sb.ToString
    End Function

End Class

